<?php //timeline.inc.php


// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: perfgraphs.inc.php 75 2010-04-01 19:40:08Z mguthrie $

include_once(dirname(__FILE__).'/../dashlethelper.inc.php');

timeline_dashlet_init();


function timeline_dashlet_init(){
	
	// respect the name!
	$name="timeline";
	
	$args=array(

		// need a name
		DASHLET_NAME => $name,
		
		// informative information
		DASHLET_VERSION => "1.0",
		DASHLET_DATE => "05-26-2012",
		DASHLET_AUTHOR => "Mike Guthrie, Nagios Enterprises, LLC",
		DASHLET_DESCRIPTION => gettext("This dashlet displays a scalable performance graph for a host or service."),
		DASHLET_COPYRIGHT => "Copyright (c) 2009-2012 Nagios Enterprises",
		DASHLET_HOMEPAGE => "http://www.nagios.com",
		
		// the good stuff - only one output method is used.  order of preference is 1) function, 2) url
		DASHLET_FUNCTION => "timeline_dashlet_func",
		
		DASHLET_TITLE => gettext("Performance Graph"),
		
		//DASHLET_OUTBOARD_CLASS => "perfgraphs_outboardclass",
		//DASHLET_INBOARD_CLASS => "perfgraphs_inboardclass",
		//DASHLET_PREVIEW_CLASS => "perfgraphs_previewclass",
		DASHLET_WIDTH => "600px",
		DASHLET_HEIGHT => "400px",
		
		DASHLET_REFRESHRATE => get_option('active_poller_interval'),
		);
	register_dashlet($name,$args);
	}



function timeline_dashlet_func($mode=DASHLET_MODE_PREVIEW,$id="",$args=null){
	//array_dump($args); 
	$output=''; 

	switch($mode){
		case DASHLET_MODE_GETCONFIGHTML:
			$optionlist = '<option value="">'.gettext('Select A Server').'</option>'; 
			foreach(get_servers() as $key => $val) {
				if($val['type']!='nagiosxi') continue; //only works for XI 
				$optionlist.="<option value='{$key}'>{$val['name']}</option>\n"; 
			}

			$output='
				
			<br />
			<label for="server">'.gettext('Server').': </label><br class="nobr" />
			<select name="sid" id="sid" onchange="gethosts()">
				'.$optionlist.'
			</select><br class="nobr" />
			<label for="width">'.gettext('Host').': </label><br class="nobr" />
			<select name="host" id="host" onchange="getservices()">
				<option value=""></option>
			 <select/><br class="nobr" />	
			 		
			<label for="url">'.gettext('Service').': </label><br class="nobr" />
			<select name="service" id="service">
				</option value=""></option>
			</select>
			
			<br class="nobr" />
							
			'; 
			
			
			break;
		case DASHLET_MODE_OUTBOARD:
			$args['mode']=$mode;
			$output.=timeline_dashlet($args);
			break; 
		case DASHLET_MODE_INBOARD:
			$args['mode']=$mode; //main Top Alert Producers page will override this
			$output.=timeline_dashlet($args);
			break;
		case DASHLET_MODE_PREVIEW:
			$output="<img src='".get_base_url()."/includes/dashlets/timeline/timeline_preview.jpg' />";
			break;
		}
	//$output.="<p>MODE: $mode, ID: $id</p>";
		
	return $output;
}



function timeline_dashlet($args) {

	//array_dump($args); 
	$height = grab_array_var($args,'iframe_height',300);
	$id="timeline_dashlet_".random_string(6);
	$id2 = $id."_2"; 
	$host = urlencode(grab_array_var($args,'host','localhost')); 
	$service = urlencode(grab_array_var($args,'service','')); 
	$sid = grab_array_var($args,'sid'); 
	$img = theme_image('throbber.gif');
	
	//echo $jargs; 

	$output="

	<div class='perfgraphscontainer'>
		<div class='fusioncore_perfgraphs' id='{$id}'></div>
			<div class='graphcontainer' id='{$id2}'><img src='{$img}' /></div>
		

		<script type='text/javascript'>
		$(document).ready(function(){
	
			get_timeline_content();
			var hc = $('#{$id2}').find('.highcharts-container');
			//var hc = $('#{$id2}');
			hc.unbind('resize');
			hc.children().unbind('resize'); 
			hc.unbind('drag');
			hc.children().unbind('drag'); 
			$('#{$id2}').draggable('destroy');
				
			$('#{$id}').everyTime(60*1000, 'timer-fusioncore_perfgraphs', function(i) {
				get_timeline_content();
			});
			
			function get_timeline_content(){						
				$('#{$id}').load('/nagiosfusion/includes/components/xidata/xidata.php?&cmd=getgraph&div={$id2}&host={$host}&service={$service}&sid={$sid}&type=timeline&height={$height}');
				$('#{$id2}').click(function(event) {	
					//if(event.target != this)					
						event.stopPropagation(); //stops problems with the zoomable graph
						$('#{$id2}').draggable('destroy');  					
				}); 
				$('#{$id2}').children().click(function(event) {
					event.stopPropagation(); //stops problems with the zoomable graph 
					$('#{$id2}').draggable('destroy');
				}); 

			}		
		});
	</script>
		
	</div>
";

	return $output; 

}

?>